<?php

/*

  osCommRes, Services Online
  http://www.oscommres.com

  Copyright (c) 2005 osCommRes

  Released under the GNU General Public License
  Freeway eCommerce from ZacWare
http://www.zac-ware.com/freeway

Copyright 2007 ZacWare Pty. Ltd 
*/
// Set flag that this is a parent file
	define( '_FEXEC', 1 );
  require('includes/application_top.php');  
  tep_get_last_access_file();
  require('includes/classes/currencies.php');
  require(DIR_WS_FUNCTIONS . 'events_tree.php');
  require(DIR_WS_CLASSES . 'split_page_results_report.php');
  define(BOX_WIDTH1,'125');
	$server_date = getServerDate(true);	
	
	// get initial parameters, first check session for previous settings
	if (isset($HTTP_GET_VARS["return"]) && isset($HTTP_SESSION_VARS["rep_params"])){
		$input_params=&$HTTP_SESSION_VARS["rep_params"];
	} else {
		$input_params=&$HTTP_POST_VARS;
		if (isset($input_params["post_action"])){
			if ($input_params["post_action"]!="change_status"){
				tep_set_session_value("rep_params",$HTTP_POST_VARS);
				$GLOBALS["rep_params"]["post_action"]="screen";
			}
		} else {
			tep_set_session_value("rep_params",array());
		}
	}


	$date_begin=isset($input_params['txt_start_date'])?tep_convert_date_raw($input_params['txt_start_date']):'';
	$date_end=isset($input_params['txt_end_date'])?tep_convert_date_raw($input_params['txt_end_date']):'';
	$instructor=isset($input_params['sel_instructor'])?$input_params['sel_instructor']:-1;
	$location=isset($input_params['sel_location'])?$input_params['sel_location']:-1;
	$customer=isset($input_params['sel_customer'])?$input_params['sel_customer']:"-1";
	$event=isset($input_params['sel_event'])?$input_params['sel_event']:-1;
	$event_show=isset($input_params['chk_event'])?true:false;
	$product_show=isset($input_params['chk_product'])?true:false;
	$summary_show=isset($input_params['chk_summary'])?true:false;
	$post_action = isset($input_params['post_action'])?$input_params['post_action']:'';
	$page = isset($input_params['page'])?$input_params['page']:1;

	$currencies=new currencies();
	
	// change the current status of selected orders
	if ($post_action=="change_status"){
		$stat_ids=$input_params["chk_status"];
		$new_status=$input_params["new_status"];
		$order_ids="";
		echo sizeof($stat_ids);
		for ($icnt=0;$icnt<sizeof($stat_ids);$icnt++){
			tep_send_products_status_change_email($stat_ids[$icnt],$new_status);
			$order_ids.=$stat_ids[$icnt] . ",";
		}
		if ($order_ids!=""){
			$order_ids=substr($order_ids,0,-1);
			tep_db_query("UPDATE " . TABLE_ORDERS . " set last_modified='" .$server_date . "',orders_status='" . $new_status . "' where orders_id in(" . $order_ids . ")");
			tep_db_query("update " . TABLE_ORDERS_PRODUCTS . " set orders_products_status= '" . $new_status . "' where orders_id = '" . (int)$order_ids . "'"); 
			echo tep_draw_form("frmSearch",FILENAME_UNPAID_PAYMENTS);
			echo '<input type="hidden" name="post_action" value="screen">';
			echo tep_get_report_params();
			echo '<script language="javascript">' .
				'document.frmSearch.submit();' .
				'</script></form>';
			return;
		}
	}

	if ($post_action==""){
		$post_action="screen";
	}
	if (!$product_show && !$event_show) {
		$event_show=true;
		$product_show=true;
	}
	if ($date_begin==""){
		$date_begin=getServerDate();
	}
	if ($date_end==""){
		//$sql =  "select date_add('$date_begin', interval -(dayofmonth('$date_begin')-1) day) begin, date_add('$date_begin', interval (30-dayofmonth('$date_begin')) day) end";	
		$sql =  "select date_add('$date_begin', interval 1 month) end";	
		$sql_result = tep_db_query($sql);
		$row = mysql_fetch_assoc($sql_result);
		
		$date_end = $row["end"];	
	}

	$customers_array = array();
	$events_array = array();
	$locations_array=array();
	$order_status_array=array();
	$status_array=array();
	

	// get instructor names			
	$sql = "select a.admin_id admin_id, admin_firstname, admin_lastname  from events_instructors ei, admin a where ei.admin_id=a.admin_id order by admin_firstname,admin_lastname";
	$sql_result = tep_db_query($sql);
	$num_rows = tep_db_num_rows($sql_result);
	$instructors_array[]=array("id"=>-1,"text"=>TEXT_ALL_INSTRUCTORS);
	while($row=tep_db_fetch_array($sql_result)) {
		$instructors_array[]=array("id"=>$row["admin_id"],"text"=>$row["admin_firstname"]." ".$row["admin_lastname"]);
	}
	mysql_free_result($sql_result);
		
	// get location names
	$sql = "select distinct location_id, location_name from events,events_locations where location_id=events_location order by location_name";
	$sql_result = tep_db_query($sql);
	$locations_array[]=array("id"=>-1,"text"=>TEXT_ALL_LOCATIONS);
	while($row=tep_db_fetch_array($sql_result)) {
		$locations_array[]=array("id"=>$row["location_id"],"text"=>$row["location_name"]);
	}
	mysql_free_result($sql_result);

	// get all  events
	$events_option="";
	if ($login_groups_type==TEXT_INSTRUCTOR_ENTRY) $events_option=" and e.events_instructor='" . $login_id . "'";
	$sql = "select e.events_id events_id, Events_name  events_name from events e, events_description ed where e.events_id = ed.events_id and ed.language_id='" . $languages_id . "'" . EVENTS_CONDITION_STATUS . $events_option . " order by events_name";
	$sql_result = tep_db_query($sql);
	$events_array[]=array("id"=>-1,"text"=>TEXT_ALL_EVENTS);
	while($row=tep_db_fetch_array($sql_result)) {
		$events_array[]=array("id"=>$row["events_id"],"text"=>$row["events_name"]);
	}
	mysql_free_result($sql_result);
	
	// get all call centre orders
	$sql="SELECT distinct c.customers_id,concat(LTRIM(c.customers_lastname),' ',LTRIM(c.customers_firstname)) as customers_name from " . TABLE_CUSTOMERS . " c, " . TABLE_ORDERS . 
			" o where c.customers_id=o.customers_id order by customers_name";
	
	$sql_result=tep_db_query($sql);
	$customers_array[]=array("id"=>"-1","text"=>TEXT_ALL_CUSTOMERS);
	while($row=tep_db_fetch_array($sql_result)){
		$customers_array[]=array("id"=>$row["customers_id"],"text"=>$row["customers_name"]);
	}
	mysql_free_result($sql_result);

	// get the mysql results;
	$sql="SELECT orders_status_id,orders_status_name from " . TABLE_ORDERS_STATUS . " where language_id='" . $languages_id . "'";
	$sql_result=tep_db_query($sql);
	$status_array=tep_get_orders_status();
	while($row=tep_db_fetch_array($sql_result)){
		$order_status_array[$row["orders_status_id"]]=$row["orders_status_name"];
		//$status_array[]=array('id'=>$row["orders_status_id"],'text'=>$row["orders_status_name"]);
	}
	
	$found_results=false;
		$where = " ";
		$db_result=array();
		$num_rows=0;
		$cur_row=0;
		$rows_each=REPORT_MAX_ROWS_PAGE;
		if ($event_show && $product_show){
			$rows_each=ceil($rows_each/2);
		}
		if ($event_show) {
			if($instructor!="-1") {
				$where.= "and e.events_instructor='".$instructor."' ";
			} 
			if($location!="-1") {
				$where.= "and e.events_location='".$location."' ";
			}
			if($event!="-1") {
				$where.= "and e.events_id='".$event."' ";
			}
			if($customer!="-1") {
				$where.= "and o.customers_id='".tep_db_prepare_input($customer)."' ";
			}
			// create the query to fetch unpaid event details
			$sql = "select o.orders_id, concat(LTRIM(c.customers_lastname),' ',LTRIM(c.customers_firstname)) as customers_name,o.customers_id,
			o.customers_email_address customers_email_address, ed.events_name item_name,e.events_id as item_id,
			events_type, waitlist_type, orders_status,sum(op.final_price) as final_price,
			op.products_tax from " . TABLE_EVENTS_SESSIONS . " es, " . TABLE_ORDERS_PRODUCTS . " op, " . TABLE_EVENTS . " e, " . TABLE_EVENTS_DESCRIPTION . 
			" ed, " . TABLE_ORDERS . " o, ". TABLE_CUSTOMERS . " c where o.customers_id=c.customers_id  and es.sessions_id = op.products_id and op.orders_id=o.orders_id and e.events_id=es.events_id and ed.language_id='" . $languages_id . "'
			and ed.events_id=e.events_id and op.products_type='E' and o.orders_status=1 and date_format(o.date_purchased,'%Y-%m-%d')>='$date_begin' and date_format(o.date_purchased,'%Y-%m-%d')<='$date_end'".$where." group by o.orders_id,e.events_id order by item_name,customers_name";
			if ($post_action=="screen"){
				$query_split1 = new splitPageResultsReport($page, $rows_each, $sql, $query_split_numrows1);
			}
					
			$db_result[$cur_row]=array("display"=>TEXT_EVENTS , "result"=>tep_db_query($sql));
			$num_rows=tep_db_num_rows($db_result[$cur_row]["result"]);
			$cur_row++;
		}
		$where=" ";
		if ($product_show) {
			if($customer!="-1") {
				$where.= "and o.customers_id='".tep_db_prepare_input($customer)."' ";
			}
			// create the query to fetch unpaid details
			$sql = "select o.orders_id, o.customers_id,concat(LTRIM(c.customers_lastname),' ',LTRIM(c.customers_firstname)) as customers_name ,op.products_id as item_id,sum(op.products_quantity) as quantity,
			o.customers_email_address customers_email_address,op.products_name as item_name,events_type, waitlist_type, orders_status,
			sum(op.final_price*op.products_quantity) as final_price,op.products_tax from " . TABLE_ORDERS_PRODUCTS . " op," . TABLE_ORDERS . " o, " . TABLE_CUSTOMERS ." c where o.customers_id=c.customers_id and o.orders_id=op.orders_id and op.orders_id=o.orders_id  
			and op.products_type!='E' and op.products_type!='S' and o.orders_status=1 and date_format(o.date_purchased,'%Y-%m-%d')>='$date_begin' and date_format(o.date_purchased,'%Y-%m-%d')<='$date_end' ".$where." group by o.orders_id order by item_name,customers_name";
			
			if ($post_action=="screen"){
				$query_split2 = new splitPageResultsReport($page, $rows_each, $sql, $query_split_numrows2,false);
			}
			
			$db_result[$cur_row]=array("display"=>TEXT_PRODUCTS , "result"=>tep_db_query($sql));
			$num_rows+=tep_db_num_rows($db_result[$cur_row]["result"]);
		}
		if ($num_rows>0) {
			$found_results=true;
			if ($post_action=="screen"){
				if ($query_split_numrows1>=$query_split_numrows2){
					$query_split=&$query_split1;
				} else {
					$query_split=&$query_split2;
				}
				$query_split_numrows=$query_split_numrows1+$query_split_numrows2;
			}
		}
?>
<!doctype html public "-//W3C//DTD HTML 4.01 Transitional//EN">
<html <?php echo HTML_PARAMS; ?>>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo CHARSET; ?>">
<title><?php echo TITLE; ?></title>
<link rel="stylesheet" type="text/css" href="includes/stylesheet.css">
<script language="javascript" src="includes/menu.js"></script>
<script language="javascript" src="includes/general.js"></script>
<script language="JavaScript" src="includes/date-picker.js"></script>
<script language="javascript">
	function showOrderDetails(id){
		location.href="orders.php?action=edit&oID="+id;
	}
	function doReport(mode) {
		strStart = document.f.txt_start_date.value.split("-");
		startDate = new Date(strStart[0], strStart[1], strStart[2]);
	
		strEnd = document.f.txt_end_date.value.split("-");
		endDate = new Date(strEnd[0], strEnd[1], strEnd[2]);
		stime=startDate.getTime();
		etime=endDate.getTime();
		//if(stime<0)
			//stime=stime * -1;
		//if(etime<0)
			//etime=etime *-1;
		if(stime>etime) {
			alert("<?php echo REPORT_START_AFTER_END?>");
			return;
		}
		document.f.submit();
	}
</script>
</head>
<body marginwidth="0" marginheight="0" topmargin="0" bottommargin="0" leftmargin="0" rightmargin="0" bgcolor="#FFFFFF">
<div id="spiffycalendar" class="text"></div>
	<!-- header //-->
	<?php require(DIR_WS_INCLUDES . 'header.php'); ?>
	<!-- header_eof //-->
	<!-- body //-->
<table border="0" width="100%" cellspacing="2" cellpadding="2">
<tr> 
	<!-- body_text //-->	  
	<td width=100% align=left valign="top">
	<table border="0" width="100%" cellspacing="0" cellpadding="2">
		<tr height="10">
			<!--<td class="pageHeading"><?php //echo HEADING_UNPAID_PAYMENTS;?></td>!-->
		</tr>
        <tr >
		  	<TD>
			<?php 	echo tep_draw_form("f",FILENAME_UNPAID_PAYMENTS);
					echo '<input type="hidden" name="post_action" value="screen">';
			?>
			<table border="0" cellspacing="3" cellpadding="2" class="searchArea" width="100%">
				<tr>
						<td nowrap="true"><?php $_array=array('d','m','Y');  $replace_array=array('DD','MM','YYYY'); 	$date_format=str_replace($_array,$replace_array,EVENTS_DATE_FORMAT);?>
						<?php echo TEXT_FROM . '&nbsp;' . tep_draw_input_field("txt_start_date",format_date($date_begin),'maxlength="10" size="10"');?>

						<a href="javascript:show_calendar('f.txt_start_date',null,null,'<?php echo $date_format;?>');"
						onmouseover="window.status='Date Picker';return true;"
						onmouseout="window.status='';return true;"><img border="none" src="images/icon_calendar.gif"/>  
						</a>
						<?php echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . TEXT_TO . '&nbsp;' . tep_draw_input_field("txt_end_date",format_date($date_end),'maxlength="10" size="10"');?>

						<a href="javascript:show_calendar('f.txt_end_date',null,null,'<?php echo $date_format;?>');"
						onmouseover="window.status='Date Picker';return true;"
						onmouseout="window.status='';return true;"><img border="none" src="images/icon_calendar.gif"/>  
						</a>
								<?php
						echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . TEXT_SHOW . '&nbsp;' . tep_draw_checkbox_field("chk_product",1,$product_show) . TEXT_PRODUCTS;
								echo '&nbsp;' . tep_draw_checkbox_field("chk_event",1,$event_show) . TEXT_EVENTS;
								echo '&nbsp;' . tep_draw_checkbox_field("chk_summary",1,$summary_show) . TEXT_SUMMARY_ONLY;?>
						
					</td>
					<td valign="middle" align="right" rowspan="3">


						<?php echo '<a href="javascript:doReport(1);">' . tep_image_button('button_report_search.gif', IMAGE_SEARCH_DETAILS) . '</a>'; ?>
					</td>
				</tr>
				<tr>

					<td nowrap="true">
						<?php 
							echo TEXT_LOCATION . '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;'  . tep_draw_pull_down_menu("sel_location",$locations_array,$location);

							$all_events_array=array();
							$all_events_array = tep_get_events_array_single();
							if(sizeof($all_events_array)<=0) echo 'Events are not Available';
							else echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . TEXT_EVENT . tep_draw_separator('pixel_trans.gif',30,10)  . tep_draw_event_select_menu('sel_event',$all_events_array,$event,' id="sel_event"');
						?>
						<?php    
							echo '&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;' . TEXT_INSTRUCTOR . '&nbsp;' . tep_draw_pull_down_menu("sel_instructor",$instructors_array,$instructor);
						?>
					</td>
				</tr>
				<tr>
					<td nowrap="true">
						<?php
								echo TEXT_CUSTOMER . '&nbsp;&nbsp;&nbsp;' . tep_draw_pull_down_menu("sel_customer",$customers_array,$customer);
								
						?>
					</td>
				</tr>
				
		</table>
		
		</form>
		</td>
	</tr>
	<tr ><td class="cell_bg_report_header">&nbsp;</td></tr>
	<script language="JavaScript">
		function validateForm(frm){
			var err="";
			var element=frm.elements["chk_status[]"];
			
			if (element.length){
			
				for (icnt=0;icnt<element.length;icnt++){
					if (element[icnt].checked) break;
				}
				if (icnt>=element.length){
					err="<?php echo addslashes(stripslashes(ERR_SELECT_ORDER));?>";
				}
			} else {
				if (!element.checked){
					err="<?php echo addslashes(stripslashes(ERR_SELECT_ORDER));?>";
				}
			}
			if (err!="") {
				alert(err);
				return false;
			}
			return true;
		}
		function selectAll(){
			var element=document.change_status.elements["chk_status[]"];
			var status=document.change_status.chk_select.checked;
			if (element.length){
				for (icnt=0;icnt<element.length;icnt++){
					element[icnt].checked=status;
				}
			} else {
				element.checked=status;			
			}
		}
	</script>
	<?php if ($found_results) {
	?>
	<tr>
		<td>
		<table border="0" width="100%" cellspacing="0" cellpadding="2">
			<tr>
				<td class="smallText" align="left">
					<?php echo $query_split->display_links($query_split_numrows, REPORT_MAX_ROWS_PAGE, REPORT_MAX_LINKS_PAGE, $page,tep_get_report_params()); ?>&nbsp;
				</td>
			</tr>
		</table>
		</td>
	</tr>
	<?php } ?>
	<tr>
		<td>
	   <table border="0" width="100%" cellspacing="1" cellpadding="1">
			<?php
				if ($found_results) {
					echo tep_draw_form("change_status",FILENAME_UNPAID_PAYMENTS,'','post','onSubmit="javascript:return validateForm(this);"');
					echo tep_get_report_params();
					echo '<input type="hidden" name="post_action" value="change_status">';
					for ($icnt=0;$icnt<sizeof($db_result);$icnt++) {
						$sql_result=&$db_result[$icnt]["result"];
			?>
				<tr>
					<td>
					<table border="0" cellpadding="2" cellspacing="0" class="searchArea" width="100%">
						<tr>
							<td class="TableHeading"><?php echo $db_result[$icnt]["display"]?></td>
						</tr>
					</table>
					</td>
				</tr>
				<tr>
					<td><?php echo tep_draw_separator('pixel_trans.gif',1,5);?></td>
				</tr>
				<tr>
					<td>
					<table border="0" cellpadding="2" cellspacing="0" width="100%">
							<tr class='dataTableHeadingTitleRow'>
								<td class='dataTableHeadingTitleContent' width="30"></td>
								<td class='dataTableHeadingTitleContent' width="30"><?php echo TEXT_ID;?></td>
								<td class='dataTableHeadingTitleContent'><?php echo TEXT_CLIENT;?></td>
								<td class='dataTableHeadingTitleContent' width="50"><?php echo TEXT_EMAIL;?></td>
								<td class='dataTableHeadingTitleContent' width="100"><?php echo TEXT_STATUS;?></td>
								<td class='dataTableHeadingTitleContent' width="100" align="right"><?php echo TEXT_AMOUNT;?></td>
							</tr>
							<tr height="10"></tr>

			<?php
					$i=1;
					$prev_customer="";
					$prev_item=0;
					$total=0;
					$grand_total=0;
          			while($row = tep_db_fetch_array($sql_result)) {
						$customer=$row["customers_id"];
						$item=$row["item_id"];
					?>
					<?php if ($prev_item!=$item) { // output the item name
								if ($total>0) { // output the total amount
						?>
							<tr>
								<td class="dataTableContent" colspan="5" align="right">
									<b><?php echo TEXT_TOTAL;?></b>
								</td>
								<td align="right" class='dataTableContent'>
									<?php echo $currencies->format($total);
										$total=0;
									?>
								</td>
							</tr>
							<tr>
								<td colspan="6"><?php echo tep_draw_separator();?></td>
							</tr>
						<?php } // total >0 ?>
							<tr>
								<td class="dataTableContent" colspan="6"><b>
									<?php
										echo $row["item_name"];
										$prev_item=$item;
									?>
									</b>
								</td>
							</tr>
					<?php 
					} // prev item 
						$amount=tep_add_tax($row['final_price'],$row["products_tax"]);
						$amount=tep_get_rounded_amount($amount);
						if (!$summary_show) {
					?>
						  <tr class='dataTableRow' height="20">
						  	  <td class='dataTableContent'><?php echo tep_draw_checkbox_field('chk_status[]',$row["orders_id"]);?></td>
							  <span onClick="javascript:location.href='<?php echo tep_href_link(FILENAME_ORDERS,'oID=' . $row["orders_id"] . '&action=edit&return=up');?>';">
								  <td class='dataTableContent' style="cursor:default;cursor:hand"><?php echo $i?></td>
								  <td class='dataTableContent' style="cursor:default;cursor:hand"><?php echo $row['customers_name']?></td>
								  <td class='dataTableContent' align="center"><a href="mailto:<?php echo $row['customers_email_address']?>"><img src="images/icons/mail.gif" border="0"></a></td>
								  <td class='dataTableContent' style="cursor:default;cursor:hand"><?php echo $order_status_array[$row['orders_status']];?></td>
								  <td class='dataTableContent' style="cursor:default;cursor:hand" align="right"><?php echo $currencies->format($amount);?></td>
							  </span>
						  </tr>
			<?php 
						} // summary show
						$i++;
						$total+=$amount;
						$grand_total+=$amount;
						}
						if ($total>0) {
						?>
							<tr>
								<td class="dataTableContent" style="cursor:hand" colspan="5" align="right">
									<b><?php echo TEXT_TOTAL;?></b>
								</td>
								<td style="cursor:hand" align="right" class='dataTableContent'>
									<?php echo $currencies->format($total);
										$total=0;
									?>
								</td>
							</tr>
							<tr>
								<td colspan="6"><?php echo tep_draw_separator();?></td>
							</tr>
						<?php } // total >0 
						if ($grand_total>0) {
						?>
							<tr>
								<td class="dataTableContent" style="cursor:hand" colspan="5" align="right">
									<b><?php echo TEXT_GRAND_TOTAL;?></b>
								</td>
								<td style="cursor:hand" align="right" class='dataTableContent'>
									<?php echo $currencies->format($grand_total);
									?>
								</td>
							</tr>
						<?php } // grand total >0 ?>
				</table>
				</td>
			</tr>
			<tr>
				<td><?php echo tep_draw_separator('pixel_trans.gif',1,5);?></td>
			</tr>
			<?php
					}
				if (!$summary_show) {
			?>
					<tr><td class="bottomLine">&nbsp;</td></tr>
					<tr>
						<td class="main" valign="top">
							<?php  echo '<input type="checkbox" name="chk_select" value="1" onClick="javascript:selectAll();">&nbsp;' . TEXT_SELECT_ALL . '&nbsp;&nbsp;'; ?>
						</td>
					</tr>
					<tr>
						<td><?php echo tep_draw_separator('pixel_trans.gif',1,5);?></td>
					</tr>
					<tr>
						<td class="main" valign="middle">
						<?php 
								echo tep_image_submit('button_change_status.gif',IMAGE_CHANGE_STATUS,'align=absmiddle') . '&nbsp;&nbsp;';
								echo tep_draw_pull_down_menu('new_status',$status_array);
						?>
						</td>
					</tr>
				<?php } ?>
				</form>	
			<?php
				}
				else{
					echo '<tr><td class="main" align="center">' . TEXT_NO_RECORDS_FOUND . '</td></tr>';
				}
			?>
	</table>
	</TD>
	</tr>
</table>
</td>
</tr>
</table>
	<!-- footer //-->
	<?php require(DIR_WS_INCLUDES . 'footer.php'); ?>
	<!-- footer_eof //-->
</body>
</html>
<?php require(DIR_WS_INCLUDES . 'application_bottom.php'); 

?>